'use strict'

function noop () {}

module.exports = function property(methods) {
  methods = methods || {}
  let flowControl = function(property, mapTo) {
    if(!methods) { return; }
    return (methods[property] || methods.default || noop)(mapTo);
  }

  flowControl.register = function register(property, mapTo) {
    methods[property] = mapTo;
    return flowControl;
  };

  flowControl.dispose = function dispose() {
    methods = void(0);
    flowControl.register = noop;
    flowControl.dispose = noop;
  };
  return flowControl;
}
