'use strict';

const chai = require('chai');
const expect = chai.expect;

const property = require('../../src/utils/property');

describe('When Property', function() {
  describe('method is call', function() {
    it('should return corresponding reference', function() {
      const obj = property({
        hello: function(properties) {
          return properties;
        }
      });
      expect(obj('hello', { test: 1 })).to.be.a('object');
      expect(obj('hello', { test: 1 })).to.have.keys('test');
      obj.dispose();
      expect(obj('hello', { test: 1 })).to.be.undefined;
    });
  });
});
