'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = property;
function noop() {}

function property(methods) {
  methods = methods || {};
  function flowControl(property, mapTo) {
    return (methods[property] || methods.default || noop)(mapTo);
  }

  flowControl.register = function register(property, mapTo) {
    methods[property] = mapTo;
    return flowControl;
  };

  flowControl.dispose = function dispose() {
    methods = void 0;
    flowControl = noop;
  };
  return flowControl;
}